//*******************************************************************************
// COPYRIGHT NOTES
// ---------------
// This source code is a part of BCGControlBar library.
// You may use, compile or redistribute it as part of your application 
// for free. You cannot redistribute it as a part of a software development 
// library without the agreement of the author. If the sources are 
// distributed along with the application, you should leave the original 
// copyright notes in the source code without any changes.
// This code can be used WITHOUT ANY WARRANTIES on your own risk.
// 
// Stas Levin <stas@iet.co.il>
//*******************************************************************************

// BCGDialogBar.cpp : implementation file
//

#include "stdafx.h"
#include "bcgcontrolbar.h"
#include "BCGDialogBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBCGDialogBar

IMPLEMENT_SERIAL(CBCGDialogBar, CDialogBar, VERSIONABLE_SCHEMA | 1)

#pragma warning (disable : 4355)

CBCGDialogBar::CBCGDialogBar() :
	m_Impl (this)
{
}

CBCGDialogBar::~CBCGDialogBar()
{
}

#pragma warning (default : 4355)

BEGIN_MESSAGE_MAP(CBCGDialogBar, CDialogBar)
	//{{AFX_MSG_MAP(CBCGDialogBar)
	ON_WM_NCPAINT()
	ON_WM_NCCALCSIZE()
	ON_WM_NCHITTEST()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CBCGDialogBar message handlers

void CBCGDialogBar::OnNcPaint() 
{
	m_Impl.DrawNcArea ();
}
//****************************************************************************************
void CBCGDialogBar::OnNcCalcSize(BOOL /*bCalcValidRects*/, NCCALCSIZE_PARAMS FAR* lpncsp) 
{
//	CDialogBar::OnNcCalcSize(bCalcValidRects, lpncsp);
	m_Impl.CalcNcSize (lpncsp);
}
//****************************************************************************************
UINT CBCGDialogBar::OnNcHitTest(CPoint /*point*/) 
{
	return HTCLIENT;
}
//****************************************************************************************
void CBCGDialogBar::DoPaint(CDC* /*pDC*/)
{	
	//--------------------------------------------
	// I'm drawing borders and gripper by myself,
	// in OnNcPaint()
	//--------------------------------------------
}
//****************************************************************************************
CSize CBCGDialogBar::CalcFixedLayout(BOOL bStretch, BOOL bHorz)
{
	CSize sizeResult = m_sizeDefault;

	if (bStretch) // if not docked stretch to fit
	{
		if (bHorz)
		{
			sizeResult.cx = 32767;
		}
		else
		{
			sizeResult.cy = 32767;
		}
	}

	//BLOCK: Adjust Margins
	{
		CRect rect; rect.SetRectEmpty();
		CalcInsideRect(rect, bHorz);
		sizeResult.cy -= rect.Height();
		sizeResult.cx -= rect.Width();

		CSize size = CControlBar::CalcFixedLayout (bStretch, bHorz);
		sizeResult.cx = max(sizeResult.cx, size.cx);
		sizeResult.cy = max(sizeResult.cy, size.cy);
	}

	return sizeResult;
}
