//*******************************************************************************
// COPYRIGHT NOTES
// ---------------
// This source code is a part of BCGControlBar library.
// You may use, compile or redistribute it as part of your application 
// for free. You cannot redistribute it as a part of a software development 
// library without the agreement of the author. If the sources are 
// distributed along with the application, you should leave the original 
// copyright notes in the source code without any changes.
// This code can be used WITHOUT ANY WARRANTIES on your own risk.
// 
// Stas Levin <stas@iet.co.il>
//*******************************************************************************

#if !defined(AFX_BCGURLLINKBUTTON_H__E903B416_9AB5_11D3_A70E_009027900694__INCLUDED_)
#define AFX_BCGURLLINKBUTTON_H__E903B416_9AB5_11D3_A70E_009027900694__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BCGURLLinkButton.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CBCGURLLinkButton window

class BCGCONTROLBARDLLEXPORT CBCGURLLinkButton : public CButton
{
// Construction
public:
	CBCGURLLinkButton();

// Attributes
public:
	COLORREF		m_clrRegular;
	COLORREF		m_clrHover;

protected:
	CFont			m_fontDefault;
	BOOL			m_bHover;
	BOOL			m_bPressed;
	CString			m_strURL;
	CString			m_strPrefix;
	CToolTipCtrl	m_wndToolTip;

// Operations
public:
	void SetURL (LPCTSTR lpszURL);			// By default, window text will be used
	void SetURLPrefix (LPCTSTR lpszPrefix);	// For example "mailto:"
	void SetTooltip (LPCTSTR lpszToolTip);	// lpszToolTip == NULL: disable tooltip

	void SizeToContent (BOOL bVCenter = FALSE, BOOL bHCenter = FALSE);

protected:
	void Release ();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBCGURLLinkButton)
	public:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBCGURLLinkButton();

	// Generated message map functions
protected:
	//{{AFX_MSG(CBCGURLLinkButton)
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnClicked();
	afx_msg void OnCancelMode();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BCGURLLINKBUTTON_H__E903B416_9AB5_11D3_A70E_009027900694__INCLUDED_)
