// BCGDevStudioExampleView.cpp : implementation of the CBCGDevStudioExampleView class
//

#include "stdafx.h"
#include "BCGDevStudioExample.h"

#include "BCGDevStudioExampleDoc.h"
#include "BCGDevStudioExampleView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBCGDevStudioExampleView

IMPLEMENT_DYNCREATE(CBCGDevStudioExampleView, CEditView)

BEGIN_MESSAGE_MAP(CBCGDevStudioExampleView, CEditView)
	//{{AFX_MSG_MAP(CBCGDevStudioExampleView)
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
	ON_WM_CONTEXTMENU()
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CEditView::OnFilePrintPreview)
	ON_COMMAND(ID_EDIT_FIND_COMBO, OnEditFind)
	ON_COMMAND(IDS_DUMMY_UNDO_ACTION, OnUndoAction)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBCGDevStudioExampleView construction/destruction

CBCGDevStudioExampleView::CBCGDevStudioExampleView()
{
	// TODO: add construction code here

}

CBCGDevStudioExampleView::~CBCGDevStudioExampleView()
{
}

BOOL CBCGDevStudioExampleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	BOOL bPreCreated = CEditView::PreCreateWindow(cs);
	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// Enable word-wrapping

	return bPreCreated;
}

/////////////////////////////////////////////////////////////////////////////
// CBCGDevStudioExampleView drawing

void CBCGDevStudioExampleView::OnDraw(CDC* pDC)
{
	CBCGDevStudioExampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CBCGDevStudioExampleView printing

BOOL CBCGDevStudioExampleView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default CEditView preparation
	return CEditView::OnPreparePrinting(pInfo);
}

void CBCGDevStudioExampleView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView begin printing.
	CEditView::OnBeginPrinting(pDC, pInfo);
}

void CBCGDevStudioExampleView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView end printing
	CEditView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CBCGDevStudioExampleView diagnostics

#ifdef _DEBUG
void CBCGDevStudioExampleView::AssertValid() const
{
	CEditView::AssertValid();
}

void CBCGDevStudioExampleView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CBCGDevStudioExampleDoc* CBCGDevStudioExampleView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBCGDevStudioExampleDoc)));
	return (CBCGDevStudioExampleDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBCGDevStudioExampleView message handlers

void CBCGDevStudioExampleView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	theApp.OnViewDoubleClick (this, IDR_BCGDEVTYPE);
}

void CBCGDevStudioExampleView::OnContextMenu(CWnd*, CPoint point)
{
	theApp.ShowPopupMenu (IDR_CONTEXT_MENU, point, this);
}

void CBCGDevStudioExampleView::OnEditFind() 
{
	CBCGToolbarComboBoxButton* pSrcCombo = NULL;

	CObList listButtons;
	if (CBCGToolBar::GetCommandButtons (ID_EDIT_FIND_COMBO, listButtons) > 0)
	{
		for (POSITION posCombo = listButtons.GetHeadPosition (); 
			pSrcCombo == NULL && posCombo != NULL;)
		{
			CBCGToolbarComboBoxButton* pCombo = 
				DYNAMIC_DOWNCAST (CBCGToolbarComboBoxButton, listButtons.GetNext (posCombo));
			ASSERT (pCombo != NULL);

			if (CBCGToolBar::IsLastCommandFromButton (pCombo))
			{
				pSrcCombo = pCombo;
			}
		}
	}

	if (pSrcCombo != NULL)
	{
		LPCSTR lpszSelItem = pSrcCombo->GetItem ();
		CString strSelItem = (lpszSelItem == NULL) ? _T("") : lpszSelItem;

		MessageBox (strSelItem);
	}
	else
	{
		CEditView::OnEditFind();
	}
}

void CBCGDevStudioExampleView::OnUndoAction()
{
	OnEditUndo(); 
}
