// WatchBar.cpp : implementation file
//

#include "stdafx.h"
#include "BCGDevStudioExample.h"
#include "WatchBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWatchBar

CWatchBar::CWatchBar()
{
}

CWatchBar::~CWatchBar()
{
}


BEGIN_MESSAGE_MAP(CWatchBar, CBCGSizingControlBar)
	//{{AFX_MSG_MAP(CWatchBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWatchBar message handlers

int CWatchBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CBCGSizingControlBar::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_Font.CreateStockObject (DEFAULT_GUI_FONT);

	CRect rectDummy;
	rectDummy.SetRectEmpty ();

	// Create tabs window:
	if (!m_wndTabs.Create (CBCGTabWnd::STYLE_FLAT_SHARED_HORZ_SCROLL, rectDummy, this, 1))
	{
		TRACE0("Failed to create output tab window\n");
		return -1;      // fail to create
	}

	// Create output panes:
	const DWORD dwStyle = WS_CHILD | WS_VISIBLE | WS_VSCROLL | LVS_REPORT;

	m_wndWatch1.Create (dwStyle, rectDummy, &m_wndTabs, 1);
	m_wndWatch1.SendMessage (LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
						LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	m_wndWatch1.InsertColumn (0, _T("Variable"), LVCFMT_LEFT, 100);
	m_wndWatch1.InsertColumn (1, _T("Value"), LVCFMT_LEFT, 100);

	m_wndTabs.AddTab (&m_wndWatch1, _T("Watch 1"), (UINT) -1);

	m_wndWatch2.Create (dwStyle, rectDummy, &m_wndTabs, 2);
	m_wndWatch2.SendMessage (LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
						LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	m_wndWatch2.InsertColumn (0, _T("Variable"), LVCFMT_LEFT, 100);
	m_wndWatch2.InsertColumn (1, _T("Value"), LVCFMT_LEFT, 100);

	m_wndTabs.AddTab (&m_wndWatch2, _T("Watch 2"), (UINT) -1);

	m_wndWatch3.Create (dwStyle, rectDummy, &m_wndTabs, 3);
	m_wndWatch3.SendMessage (LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
						LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	m_wndWatch3.InsertColumn (0, _T("Variable"), LVCFMT_LEFT, 100);
	m_wndWatch3.InsertColumn (1, _T("Value"), LVCFMT_LEFT, 100);

	m_wndTabs.AddTab (&m_wndWatch3, _T("Watch 3"), (UINT) -1);

	m_wndWatch4.Create (dwStyle, rectDummy, &m_wndTabs, 4);
	m_wndWatch4.SendMessage (LVM_SETEXTENDEDLISTVIEWSTYLE, 0,
						LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	m_wndWatch4.InsertColumn (0, _T("Variable"), LVCFMT_LEFT, 100);
	m_wndWatch4.InsertColumn (1, _T("Value"), LVCFMT_LEFT, 100);

	m_wndTabs.AddTab (&m_wndWatch4, _T("Watch 4"), (UINT) -1);

	return 0;
}

void CWatchBar::OnSize(UINT nType, int cx, int cy) 
{
	CBCGSizingControlBar::OnSize(nType, cx, cy);

    CRect rc;
    GetClientRect(rc);

	m_wndTabs.SetWindowPos(NULL,
            rc.left, rc.top,
            rc.Width(), rc.Height (),
            SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOREDRAW);
}

/////////////////////////////////////////////////////////////////////////////
// CWatchList

CWatchList::CWatchList()
{
}

CWatchList::~CWatchList()
{
}


BEGIN_MESSAGE_MAP(CWatchList, CListCtrl)
	//{{AFX_MSG_MAP(CWatchList)
	ON_WM_WINDOWPOSCHANGING()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWatchList message handlers

void CWatchList::OnWindowPosChanging(WINDOWPOS FAR* lpwndpos) 
{
	CListCtrl::OnWindowPosChanging(lpwndpos);
	
	// Hide horizontal scrollbar:
	ShowScrollBar (SB_HORZ, FALSE);
	ModifyStyle (WS_HSCROLL, 0, SWP_DRAWFRAME);
}
