// WorkspaceBar.cpp : implementation file
//

#include "stdafx.h"
#include "BCGDevStudioExample.h"
#include "WorkspaceBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWorkspaceBar

CWorkspaceBar::CWorkspaceBar()
{
}

CWorkspaceBar::~CWorkspaceBar()
{
}


BEGIN_MESSAGE_MAP(CWorkspaceBar, CBCGSizingControlBar)
	//{{AFX_MSG_MAP(CWorkspaceBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWorkspaceBar message handlers

int CWorkspaceBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CBCGSizingControlBar::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	CRect rectDummy;
	rectDummy.SetRectEmpty ();

	// Create tabs window:
	if (!m_wndTabs.Create (CBCGTabWnd::STYLE_3D, rectDummy, this, 1))
	{
		TRACE0("Failed to create workspace tab window\n");
		return -1;      // fail to create
	}

	m_wndTabs.SetImageList (IDB_WORKSPACE, 16, RGB (255, 0, 0));

	// Create views:
	const DWORD dwViewStyle =	WS_CHILD | WS_VISIBLE | TVS_HASLINES | 
								TVS_LINESATROOT | TVS_HASBUTTONS;
	
	if (!m_wndClassView.Create (dwViewStyle, rectDummy, &m_wndTabs, 2) ||
		!m_wndResourceView.Create (dwViewStyle, rectDummy, &m_wndTabs, 3) ||
		!m_wndFileView.Create (dwViewStyle, rectDummy, &m_wndTabs, 4))
	{
		TRACE0("Failed to create workspace view\n");
		return -1;      // fail to create
	}

	// Load view images:
	m_ClassViewImages.Create (IDB_CLASS_VIEW, 16, 0, RGB (255, 0, 0));
	m_wndClassView.SetImageList (&m_ClassViewImages, TVSIL_NORMAL);

	m_ResourceViewImages.Create (IDB_RESOURCE_VIEW, 16, 0, RGB (255, 0, 255));
	m_wndResourceView.SetImageList (&m_ResourceViewImages, TVSIL_NORMAL);

	m_FileViewImages.Create (IDB_FILE_VIEW, 16, 0, RGB (255, 0, 255));
	m_wndFileView.SetImageList (&m_FileViewImages, TVSIL_NORMAL);

	// Fill view context (dummy code, don't seek here something magic :-)):
	FillClassView ();
	FillResourceView ();
	FillFileView ();

	// Attach views to tab:
	m_wndTabs.AddTab (&m_wndClassView, _T("ClassView"), 0 /* Image number */);
	m_wndTabs.AddTab (&m_wndResourceView, _T("ResourceView"), 1 /* Image number */);
	m_wndTabs.AddTab (&m_wndFileView, _T("FileView"), 2 /* Image number */);
	return 0;
}

void CWorkspaceBar::OnSize(UINT nType, int cx, int cy) 
{
	CBCGSizingControlBar::OnSize(nType, cx, cy);

	m_wndTabs.SetWindowPos (NULL, -1, -1, cx, cy,
		SWP_NOMOVE | SWP_NOACTIVATE | SWP_NOZORDER);
}

void CWorkspaceBar::FillClassView ()
{
	HTREEITEM hRoot = m_wndClassView.InsertItem (_T("HelloBCG classes"), 0, 0);
	m_wndClassView.SetItemState (hRoot, TVIS_BOLD, TVIS_BOLD);

	HTREEITEM hClass = m_wndClassView.InsertItem (_T("CAboutDlg"), 1, 1, hRoot);
	m_wndClassView.InsertItem (_T("CAboutDlg()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("DoDataExchange(CDataExchange* pDX)"), 4, 4, hClass);

	m_wndClassView.Expand (hRoot, TVE_EXPAND);

	hClass = m_wndClassView.InsertItem (_T("CHelloBCGApp"), 1, 1, hRoot);
	m_wndClassView.InsertItem (_T("CHelloBCGApp()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("InitInstance()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("OnAppAbout()"), 3, 3, hClass);

	hClass = m_wndClassView.InsertItem (_T("CHelloBCGDoc"), 1, 1, hRoot);
	m_wndClassView.InsertItem (_T("AssertValid()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("CHelloBCGDoc()"), 4, 4, hClass);
	m_wndClassView.InsertItem (_T("~CHelloBCGDoc()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("Dump(CDumpContext& dc)"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("OnNewDocument()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("Serialize()"), 3, 3, hClass);

	hClass = m_wndClassView.InsertItem (_T("CHelloBCGView"), 1, 1, hRoot);
	m_wndClassView.InsertItem (_T("AssertValid()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("CHelloBCGView()"), 4, 4, hClass);
	m_wndClassView.InsertItem (_T("~CHelloBCGView()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("Dump(CDumpContext& dc)"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("GetDocument()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("OnDraw(CDC* pDC)"), 3, 3, hClass);
	m_wndClassView.Expand (hClass, TVE_EXPAND);

	hClass = m_wndClassView.InsertItem (_T("CMainFrame"), 1, 1, hRoot);
	m_wndClassView.InsertItem (_T("AssertValid()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("CMainFrame()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("~CMainFrame()"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("Dump(CDumpContext& dc)"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("OnCreate(LPCREATESTRUCT lpCreateStruct)"), 4, 4, hClass);
	m_wndClassView.InsertItem (_T("PreCreateWindow(CREATESTRUCT& cs)"), 3, 3, hClass);
	m_wndClassView.InsertItem (_T("m_wndMenuBar"), 6, 6, hClass);
	m_wndClassView.InsertItem (_T("m_wndToolBar"), 6, 6, hClass);
	m_wndClassView.InsertItem (_T("m_wndStatusBar"), 6, 6, hClass);

	hClass = m_wndClassView.InsertItem (_T("Globals"), 2, 2, hRoot);
	m_wndClassView.InsertItem (_T("theApp"), 5, 5, hClass);
	m_wndClassView.Expand (hClass, TVE_EXPAND);
}

void CWorkspaceBar::FillResourceView ()
{
	HTREEITEM hRoot = m_wndResourceView.InsertItem (_T("HelloBCG resources"), 0, 0);
	m_wndResourceView.SetItemState (hRoot, TVIS_BOLD, TVIS_BOLD);

	HTREEITEM hFolder = m_wndResourceView.InsertItem (_T("Accelerator"), 0, 0, hRoot);
	m_wndResourceView.InsertItem (_T("IDR_MAINFRAME"), 1, 1, hFolder);

	m_wndResourceView.Expand (hRoot, TVE_EXPAND);

	hFolder = m_wndResourceView.InsertItem (_T("Dialog"), 0, 0, hRoot);
	m_wndResourceView.InsertItem (_T("IDD_ABOUTBOX"), 3, 3, hFolder);

	hFolder = m_wndResourceView.InsertItem (_T("Icon"), 0, 0, hRoot);
	m_wndResourceView.InsertItem (_T("IDR_HELLO"), 4, 4, hFolder);
	m_wndResourceView.InsertItem (_T("IDR_MAINFRAME"), 4, 4, hFolder);

	m_wndResourceView.Expand (hFolder, TVE_EXPAND);

	hFolder = m_wndResourceView.InsertItem (_T("Menu"), 0, 0, hRoot);
	m_wndResourceView.InsertItem (_T("IDR_CONTEXT_MENU"), 5, 5, hFolder);
	m_wndResourceView.InsertItem (_T("IDR_HELLO"), 5, 5, hFolder);
	m_wndResourceView.InsertItem (_T("IDR_MAINFRAME"), 5, 5, hFolder);
	m_wndResourceView.InsertItem (_T("IDR_POPUP_TOOLBAR"), 5, 5, hFolder);

	m_wndResourceView.Expand (hFolder, TVE_EXPAND);

	hFolder = m_wndResourceView.InsertItem (_T("String Table"), 0, 0, hRoot);
	m_wndResourceView.InsertItem (_T("String Table"), 6, 6, hFolder);

	hFolder = m_wndResourceView.InsertItem (_T("Toolbar"), 0, 0, hRoot);
	m_wndResourceView.InsertItem (_T("IDR_MAINFRAME"), 7, 7, hFolder);

	hFolder = m_wndResourceView.InsertItem (_T("Version"), 0, 0, hRoot);
	m_wndResourceView.InsertItem (_T("VS_VERSION_INFO"), 8, 8, hFolder);
}

void CWorkspaceBar::FillFileView ()
{
	HTREEITEM hRoot = m_wndFileView.InsertItem (_T("HelloBCG files"), 0, 0);
	m_wndFileView.SetItemState (hRoot, TVIS_BOLD, TVIS_BOLD);

	HTREEITEM hSrc = m_wndFileView.InsertItem (_T("Source Files"), 0, 0, hRoot);

	m_wndFileView.InsertItem (_T("HelloBCG.cpp"), 1, 1, hSrc);
	m_wndFileView.InsertItem (_T("HelloBCG.rc"), 1, 1, hSrc);
	m_wndFileView.InsertItem (_T("HelloBCGDoc.cpp"), 1, 1, hSrc);
	m_wndFileView.InsertItem (_T("HelloBCGView.cpp"), 1, 1, hSrc);
	m_wndFileView.InsertItem (_T("MainFrm.cpp"), 1, 1, hSrc);
	m_wndFileView.InsertItem (_T("StdAfx.cpp"), 1, 1, hSrc);

	HTREEITEM hInc = m_wndFileView.InsertItem (_T("Header Files"), 0, 0, hRoot);

	m_wndFileView.InsertItem (_T("HelloBCG.h"), 2, 2, hInc);
	m_wndFileView.InsertItem (_T("HelloBCGDoc.h"), 2, 2, hInc);
	m_wndFileView.InsertItem (_T("HelloBCGView.h"), 2, 2, hInc);
	m_wndFileView.InsertItem (_T("resource.h"), 2, 2, hInc);
	m_wndFileView.InsertItem (_T("MainFrm.h"), 2, 2, hInc);
	m_wndFileView.InsertItem (_T("StdAfx.h"), 2, 2, hInc);

	HTREEITEM hRes = m_wndFileView.InsertItem (_T("Resource Files"), 0, 0, hRoot);

	m_wndFileView.InsertItem (_T("HelloBCG.ico"), 2, 2, hRes);
	m_wndFileView.InsertItem (_T("HelloBCG.rc2"), 2, 2, hRes);
	m_wndFileView.InsertItem (_T("HelloBCGDoc.ico"), 2, 2, hRes);
	m_wndFileView.InsertItem (_T("Toolbar.bmp"), 2, 2, hRes);

	m_wndFileView.Expand (hRoot, TVE_EXPAND);
	m_wndFileView.Expand (hSrc, TVE_EXPAND);
	m_wndFileView.Expand (hInc, TVE_EXPAND);
}
