// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "afxpriv.h"
#include "CustToolBarTest.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int  iMaxUserToolbars		= 10;

const UINT uiMenuBarId			= AFX_IDW_CONTROLBAR_FIRST + 20;
const UINT uiUserBarId			= AFX_IDW_CONTROLBAR_FIRST + 21;
const UINT uiOutlookBarId		= AFX_IDW_CONTROLBAR_FIRST + 22;
const UINT uiFirstUserToolBarId	= AFX_IDW_CONTROLBAR_FIRST + 40;
const UINT uiLastUserToolBarId	= uiFirstUserToolBarId + iMaxUserToolbars - 1;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CBCGMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CBCGMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_USER_TOOBAR, OnViewUserToobar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_USER_TOOBAR, OnUpdateViewUserToobar)
	ON_COMMAND(ID_VIEW_CUSTOMIZE, OnViewCustomize)
	ON_COMMAND(ID_USER_CONFIGURATION, OnUserConfiguration)
	ON_COMMAND(ID_POPUP_ONE, OnPopupOne)
	ON_COMMAND(ID_POPUP_TWO, OnPopupTwo)
	ON_COMMAND(ID_VIEW_GOTO_HOME, OnViewGotoHome)
	ON_COMMAND(ID_VIEW_GOTO_CALENDAR, OnViewGotoCalendar)
	ON_COMMAND(ID_VIEW_GOTO_DRAFTS, OnViewGotoDrafts)
	ON_COMMAND(ID_VIEW_GOTO_INBOX, OnViewGotoInbox)
	ON_COMMAND(ID_VIEW_GOTO_JOURNAL, OnViewGotoJournal)
	ON_COMMAND(ID_VIEW_GOTO_NOTES, OnViewGotoNotes)
	ON_COMMAND(ID_VIEW_GOTO_OUTBOX, OnViewGotoOutbox)
	ON_COMMAND(ID_VIEW_GOTO_SENTITEMS, OnViewGotoSentitems)
	ON_COMMAND(ID_VIEW_GOTO_TASKS, OnViewGotoTasks)
	ON_COMMAND(ID_EDIT_NAME, OnEditName)
	ON_COMMAND(ID_VIEW_OUTLOOK_BAR, OnViewOutlookBar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_OUTLOOK_BAR, OnUpdateViewOutlookBar)
	ON_COMMAND(ID_OUTLOOK_SHOW_BACKGROUND, OnOutlookShowBackground)
	ON_UPDATE_COMMAND_UI(ID_OUTLOOK_SHOW_BACKGROUND, OnUpdateOutlookShowBackground)
	ON_COMMAND(ID_OUTLOOK_SHOW_TEXT_LABELS, OnOutlookShowTextLabels)
	ON_UPDATE_COMMAND_UI(ID_OUTLOOK_SHOW_TEXT_LABELS, OnUpdateOutlookShowTextLabels)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_USER_TOOLS, OnUserTool)
	ON_COMMAND_EX_RANGE(ID_VIEW_USER_TOOLBAR1, ID_VIEW_USER_TOOLBAR10, OnToolsViewUserToolbar)
	ON_UPDATE_COMMAND_UI_RANGE(ID_VIEW_USER_TOOLBAR1, ID_VIEW_USER_TOOLBAR10, OnUpdateToolsViewUserToolbar)
	ON_REGISTERED_MESSAGE(BCGM_TOOLBARMENU, OnToolbarContextMenu)
	ON_REGISTERED_MESSAGE(BCGM_CUSTOMIZEHELP, OnHelpCustomizeToolbars)
	ON_REGISTERED_MESSAGE(BCGM_RESETTOOLBAR, OnToolbarReset)
	ON_CBN_SELENDOK(ID_USER_CONFIGURATION, OnSelectUserConfiguration)
	ON_UPDATE_COMMAND_UI_RANGE(ID_USER_TOOL1, ID_USER_TOOL10, OnUpdateUserTools)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CBCGMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	//--------------------------
	// Load toolbar user images:
	//--------------------------
	if (!m_UserImages.Load (_T("User Buttons.bmp")))
	{
		MessageBox ("Can't find 'User Buttons.bmp' file");

		TRACE0("Failed to load user images\n");
		return -1;      // fail to create
	}

	CList<UINT, UINT>	lstBasicCoomads;
	lstBasicCoomads.AddTail (ID_EDIT_CUT);
	lstBasicCoomads.AddTail (ID_EDIT_PASTE);
	lstBasicCoomads.AddTail (ID_FILE_NEW);
	lstBasicCoomads.AddTail (ID_FILE_OPEN);
	lstBasicCoomads.AddTail (ID_FILE_SAVE);
	lstBasicCoomads.AddTail (ID_FILE_PRINT);
	lstBasicCoomads.AddTail (ID_APP_EXIT);
	lstBasicCoomads.AddTail (ID_EDIT_UNDO);
	lstBasicCoomads.AddTail (ID_USER_TOOL1);
	lstBasicCoomads.AddTail (ID_USER_TOOL3);
	lstBasicCoomads.AddTail (ID_APP_ABOUT);
	lstBasicCoomads.AddTail (ID_VIEW_TOOLBAR);
	lstBasicCoomads.AddTail (ID_USER_CONFIGURATION);
	lstBasicCoomads.AddTail (ID_VIEW_CUSTOMIZE);
	lstBasicCoomads.AddTail (ID_POPUP_ONE);
	lstBasicCoomads.AddTail (ID_VIEW_TOOLBARS);

	CBCGToolBar::SetBasicCommands (lstBasicCoomads);

	CBCGToolBar::SetUserImages (&m_UserImages);

	//------------------------------------------
	// Create and setup "Outlook" shortcuts bar:
	//------------------------------------------
	if (!m_wndBarOutlook.Create(this, 
		WS_CHILD | WS_VISIBLE | CBRS_LEFT | CBRS_HIDE_INPLACE,
		uiOutlookBarId))
	{
		TRACE0("Failed to create dialog bar m_wndBarOutlook\n");
		return -1;		// fail to create
	}

	m_wndBarOutlook.SetTransparentColor (RGB (255, 0, 255));

	m_wndBarOutlook.AddButton(IDB_OUTLOOK, _T("Home"), ID_VIEW_GOTO_HOME);
	m_wndBarOutlook.AddButton(IDB_CALENDAR, _T("Calendar"), ID_VIEW_GOTO_CALENDAR);
	m_wndBarOutlook.AddButton(IDB_DRAFTS, _T("Drafts"), ID_VIEW_GOTO_DRAFTS);
	m_wndBarOutlook.AddButton(IDB_INBOX, _T("Inbox"), ID_VIEW_GOTO_INBOX);
	m_wndBarOutlook.AddButton(IDB_JOURNAL, _T("Journal"), ID_VIEW_GOTO_JOURNAL);
	m_wndBarOutlook.AddButton(IDB_NOTES, _T("Notes"), ID_VIEW_GOTO_NOTES);
	m_wndBarOutlook.AddButton(IDB_OUTBOX, _T("Outbox"), ID_VIEW_GOTO_OUTBOX);
	m_wndBarOutlook.AddButton(IDB_SENT, _T("Sent Items"), ID_VIEW_GOTO_SENTITEMS);
	m_wndBarOutlook.AddButton(IDB_TASKS, _T("Tasks"), ID_VIEW_GOTO_TASKS);

	m_wndBarOutlook.SetBackImage (IDB_OUTLOOK_BACK);
	m_wndBarOutlook.SetTextColor (RGB (0, 0, 0));
	m_wndBarOutlook.EnableTextLabels (TRUE);

	//----------------------------------------------
	// Create menu bar (replaces the standard menu):
	//----------------------------------------------
	if (!m_wndMenuBar.Create (this, WS_CHILD | WS_VISIBLE | CBRS_TOP, uiMenuBarId))
	{
		TRACE0("Failed to create menubar\n");
		return -1;      // fail to create
	}

	m_wndMenuBar.SetBarStyle(m_wndMenuBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	//---------------------------
	// Load the standard toolbar:
	//---------------------------
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetWindowText (_T("Standard"));

	//-------------------------
	// Load the "user" toolbar:
	//-------------------------
	if (!m_wndUserToolBar.Create(this, 
		WS_CHILD | WS_VISIBLE | CBRS_BOTTOM | CBRS_HIDE_INPLACE, 
		uiUserBarId))
	{
		TRACE0("Failed to create user toolbar\n");
		return -1;      // fail to create
	}

	m_wndUserToolBar.SetWindowText (_T("User"));

	CMenu menu;
	menu.LoadMenu (IDR_BUTTON_MENU);
	CMenu* pPopupMenu = menu.GetSubMenu (0);
	VERIFY (pPopupMenu != NULL);

	m_wndUserToolBar.InsertButton (CBCGToolbarMenuButton 
		(ID_USER_TOOLS, pPopupMenu->GetSafeHmenu (), 0, "Select", TRUE));
	m_wndUserToolBar.InsertButton (CBCGToolbarButton 
		(ID_USER_TOOL1, 1, "User Tool 1", TRUE));
	m_wndUserToolBar.InsertButton (CBCGToolbarButton 
		(ID_USER_TOOL2, 2, "User Tool 2", TRUE));
	m_wndUserToolBar.InsertButton (CBCGToolbarButton 
		(ID_USER_TOOL3, 3, "User Tool 3", TRUE));


	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndUserToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndMenuBar.EnableDocking (CBRS_ALIGN_ANY);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndUserToolBar.EnableDocking(CBRS_ALIGN_ANY);

	EnableDocking(CBRS_ALIGN_ANY);

	DockControlBar (&m_wndMenuBar);
	DockControlBar(&m_wndToolBar);
	DockControlBar(&m_wndUserToolBar, AFX_IDW_DOCKBAR_BOTTOM);

	//----------------------------------------------
	// Enable quick customization mode ("Alt+drag"):
	//----------------------------------------------
	CBCGToolBar::EnableQuickCustomization ();

	//----------------------------------------
	// Allow user-defined toolbars operations:
	//----------------------------------------
	InitUserToobars (NULL,
					uiFirstUserToolBarId,
					uiLastUserToolBarId);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CBCGMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CBCGMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CBCGMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnViewUserToobar() 
{
	ShowControlBar (&m_wndUserToolBar,
					!(m_wndUserToolBar.GetStyle () & WS_VISIBLE),
					FALSE);
}

void CMainFrame::OnUpdateViewUserToobar(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (m_wndUserToolBar.GetStyle () & WS_VISIBLE);
}

void CMainFrame::OnViewCustomize() 
{
	//------------------------------------
	// Create a customize toolbars dialog:
	//------------------------------------
	CBCGToolbarCustomize* pDlgCust = new CBCGToolbarCustomize (this,
		TRUE /* Automatic menus scaning */);

	//--------------
	// Adjust combo:
	//--------------
	CBCGToolbarComboBoxButton comboButton (ID_USER_CONFIGURATION, 
		CImageHash::GetImageOfCommand (ID_USER_CONFIGURATION, FALSE));
	comboButton.AddItem ("Win32 Debug");
	comboButton.AddItem ("Win32 Release");
	comboButton.AddItem ("Win32 Unicode Debug");
	comboButton.AddItem ("Win32 Unicode Release");

	pDlgCust->ReplaceButton (ID_USER_CONFIGURATION, comboButton);

	//-------------
	// Adjust edit:
	//-------------
	CBCGToolbarEditBoxButton editButton (ID_EDIT_NAME,
		CImageHash::GetImageOfCommand (ID_EDIT_NAME, FALSE));
	pDlgCust->ReplaceButton (ID_EDIT_NAME, editButton);

	//-----------------------
	// Insert "user" toolbar:
	//-----------------------
	CMenu menu;
	menu.LoadMenu (IDR_BUTTON_MENU);
	CMenu* pPopupMenu = menu.GetSubMenu (0);
	VERIFY (pPopupMenu != NULL);

	pDlgCust->AddButton ("User",
		CBCGToolbarMenuButton (0, pPopupMenu->GetSafeHmenu (), 0, "Select", TRUE));
	pDlgCust->AddButton ("User", 
		CBCGToolbarButton (ID_USER_TOOL1, 1, "User Tool 1", TRUE));
	pDlgCust->AddButton ("User", 
		CBCGToolbarButton (ID_USER_TOOL2, 2, "User Tool 2", TRUE));
	pDlgCust->AddButton ("User", 
		CBCGToolbarButton (ID_USER_TOOL3, 3, "User Tool 3", TRUE));

	pDlgCust->SetUserCategory ("User");

	pDlgCust->EnableUserDefinedToolbars ();
	pDlgCust->Create ();
}

//////////////////////////////////////////////
// Toobar message handlers

LRESULT CMainFrame::OnToolbarContextMenu (WPARAM wp,LPARAM lp)
{
	BOOL bOutlookbarMenu = 
		DYNAMIC_DOWNCAST (	CBCGOutlookBar, 
							CWnd::FromHandlePermanent ((HWND) wp)) != NULL;

	CMenu menu;
	VERIFY(menu.LoadMenu (IDR_POPUP_TOOLBAR));

	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);

	SetupToolbarMenu (*pPopup, ID_VIEW_USER_TOOLBAR1, ID_VIEW_USER_TOOLBAR10);

	if (!bOutlookbarMenu)
	{
		pPopup->DeleteMenu (ID_OUTLOOK_SHOW_BACKGROUND, MF_BYCOMMAND);
		pPopup->DeleteMenu (ID_OUTLOOK_SHOW_TEXT_LABELS, MF_BYCOMMAND);
	}

	CBCGPopupMenu* pPopupMenu = new CBCGPopupMenu;
	
	CPoint point (LOWORD (lp), HIWORD(lp));
	pPopupMenu->Create (this, point.x, point.y, pPopup->Detach ());

	return 0;
}
//**********************************************************************************
void CMainFrame::OnToolsViewUserToolbar (UINT uiId)
{
	CBCGToolBar* pUserToolBar = GetUserBarByIndex (uiId - ID_VIEW_USER_TOOLBAR1);
	if (pUserToolBar == NULL)
	{
		ASSERT (FALSE);
		return;
	}

	ShowControlBar (pUserToolBar, !(pUserToolBar->GetStyle () & WS_VISIBLE), FALSE);
	RecalcLayout ();
}
//**********************************************************************************
void CMainFrame::OnUpdateToolsViewUserToolbar (CCmdUI* pCmdUI)
{
	CBCGToolBar* pUserToolBar = GetUserBarByIndex (pCmdUI->m_nID - ID_VIEW_USER_TOOLBAR1);
	if (pUserToolBar == NULL)
	{
		pCmdUI->Enable (FALSE);
		return;
	}

	pCmdUI->Enable ();
	pCmdUI->SetCheck (pUserToolBar->GetStyle () & WS_VISIBLE);
}
//**********************************************************************************
LRESULT CMainFrame::OnHelpCustomizeToolbars(WPARAM wp, LPARAM lp)
{
	int iPageNum = (int) wp;

	CBCGToolbarCustomize* pDlg = (CBCGToolbarCustomize*) lp;
	ASSERT_VALID (pDlg);

	// Test!
	CString str;
	str.Format ("Help about page number %d", iPageNum);

	MessageBox (str);

	return 0;
}
//**********************************************************************************
afx_msg LRESULT CMainFrame::OnToolbarReset(WPARAM wp,LPARAM)
{
	UINT uiToolBarId = (UINT) wp;
	if (uiToolBarId == IDR_MAINFRAME)
	{
		//----------------------------------------
		// Add a combobox to the standard toolbar:
		//----------------------------------------
		CBCGToolbarComboBoxButton comboButton (ID_USER_CONFIGURATION, 
			CImageHash::GetImageOfCommand (ID_USER_CONFIGURATION, FALSE));
		comboButton.AddItem ("Win32 Debug");
		comboButton.AddItem ("Win32 Release");
		comboButton.AddItem ("Win32 Unicode Debug");
		comboButton.AddItem ("Win32 Unicode Release");

		int iIndex = m_wndToolBar.CommandToIndex (ID_USER_CONFIGURATION);
		m_wndToolBar.RemoveButton (iIndex);

		if (iIndex > m_wndToolBar.GetCount ())
		{
			iIndex = m_wndToolBar.GetCount ();
		}

		m_wndToolBar.InsertButton (comboButton, iIndex);


		//----------------------------------------
		// Add a editbox to the standard toolbar:
		//----------------------------------------
		CBCGToolbarEditBoxButton editButton (ID_EDIT_NAME, 
			CImageHash::GetImageOfCommand (ID_EDIT_NAME, FALSE));

		iIndex = m_wndToolBar.CommandToIndex (ID_EDIT_NAME);
		m_wndToolBar.RemoveButton (iIndex);

		if (iIndex > m_wndToolBar.GetCount ())
		{
			iIndex = m_wndToolBar.GetCount ();
		}

		m_wndToolBar.InsertButton (editButton, iIndex);
	}

	return 0;
}

//--------------------
// Command examples:
//--------------------
void CMainFrame::OnUserConfiguration() 
{
	MessageBox ("Show User configuration Dlg....");
}
//**********************************************************************************
void CMainFrame::OnPopupOne() 
{
	MessageBox ("Say One!");
}
//**********************************************************************************
void CMainFrame::OnPopupTwo() 
{
	MessageBox ("Say Two!");
}
//**********************************************************************************
void CMainFrame::OnSelectUserConfiguration()
{
	CBCGToolbarComboBoxButton* pSrcCombo = NULL;

	CObList listButtons;
	if (CBCGToolBar::GetCommandButtons (ID_USER_CONFIGURATION, listButtons) > 0)
	{
		for (POSITION posCombo = listButtons.GetHeadPosition (); 
			pSrcCombo == NULL && posCombo != NULL;)
		{
			CBCGToolbarComboBoxButton* pCombo = 
				DYNAMIC_DOWNCAST (CBCGToolbarComboBoxButton, listButtons.GetNext (posCombo));
			ASSERT (pCombo != NULL);

			if (CBCGToolBar::IsLastCommandFromButton (pCombo))
			{
				pSrcCombo = pCombo;
			}
		}
	}

	if (pSrcCombo != NULL)
	{
		LPCSTR lpszSelItem = pSrcCombo->GetItem ();
		CString strSelItem = (lpszSelItem == NULL) ? _T("") : lpszSelItem;

		MessageBox (strSelItem);
	}
	else
	{
		OnUserConfiguration();
	}
}
//**********************************************************************************
void CMainFrame::OnUserTool ()
{
	MessageBox ("User Tool.");
}

void CMainFrame::OnViewGotoHome() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnViewGotoCalendar() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnViewGotoDrafts() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnViewGotoInbox() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnViewGotoJournal() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnViewGotoNotes() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnViewGotoOutbox() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnViewGotoSentitems() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnViewGotoTasks() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnEditName() 
{
	CBCGToolbarEditBoxButton* pSrcEdit = NULL;

	CObList listButtons;
	if (CBCGToolBar::GetCommandButtons (ID_EDIT_NAME, listButtons) > 0)
	{
		for (POSITION pos = listButtons.GetHeadPosition (); 
			pSrcEdit == NULL && pos != NULL;)
		{
			CBCGToolbarEditBoxButton* pEdit = 
				DYNAMIC_DOWNCAST (CBCGToolbarEditBoxButton, listButtons.GetNext (pos));
			ASSERT (pEdit != NULL);

			if (::GetFocus () == pEdit->GetHwnd ())
			{
				pSrcEdit = pEdit;
			}
		}
	}

	if (pSrcEdit != NULL && pSrcEdit->GetEditBox () != NULL &&
		(pSrcEdit->GetEditBox ()->GetStyle () & WS_VISIBLE))
	{
		CString strName;
		pSrcEdit->GetEditBox ()->GetWindowText (strName);
		CString strMsg = _T("Name is: ");
		strMsg += strName;
		MessageBox (strMsg);
	}
	else
	{
		MessageBox ("Enter name here....");
	}
}

void CMainFrame::OnViewOutlookBar() 
{
	ShowControlBar (&m_wndBarOutlook,
					!(m_wndBarOutlook.GetStyle () & WS_VISIBLE),
					FALSE);
	RecalcLayout ();
}

void CMainFrame::OnUpdateViewOutlookBar(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (m_wndBarOutlook.GetStyle () & WS_VISIBLE);
}

void CMainFrame::OnOutlookShowBackground() 
{
	m_wndBarOutlook.SetBackImage (
			m_wndBarOutlook.IsBackgroundTexture () ? 0 : IDB_OUTLOOK_BACK);

	m_wndBarOutlook.SetTextColor (
		m_wndBarOutlook.IsBackgroundTexture () ?
			RGB (0, 0, 0) : ::GetSysColor (COLOR_WINDOW));
}

void CMainFrame::OnUpdateOutlookShowBackground(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (m_wndBarOutlook.IsBackgroundTexture ());
}

void CMainFrame::OnOutlookShowTextLabels()
{
	m_wndBarOutlook.EnableTextLabels (!m_wndBarOutlook.AreTextLabels ());
}

void CMainFrame::OnUpdateOutlookShowTextLabels(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (m_wndBarOutlook.AreTextLabels ());
}

BOOL CMainFrame::OnShowPopupMenu (CBCGPopupMenu* pMenuPopup)
{
    CBCGMDIFrameWnd::OnShowPopupMenu (pMenuPopup);

    if (pMenuPopup != NULL &&
		pMenuPopup->GetMenuBar ()->CommandToIndex (ID_VIEW_TOOLBARS) >= 0)
    {
		if (CBCGToolBar::IsCustomizeMode ())
		{
			return FALSE;
		}

		pMenuPopup->RemoveAllItems ();

		CMenu menu;
		VERIFY(menu.LoadMenu (IDR_POPUP_TOOLBAR));

		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);

		SetupToolbarMenu (*pPopup, ID_VIEW_USER_TOOLBAR1, ID_VIEW_USER_TOOLBAR10);

		pPopup->DeleteMenu (ID_OUTLOOK_SHOW_BACKGROUND, MF_BYCOMMAND);
		pPopup->DeleteMenu (ID_OUTLOOK_SHOW_TEXT_LABELS, MF_BYCOMMAND);

		pMenuPopup->GetMenuBar ()->ImportFromMenu (*pPopup, TRUE);
    }

	return TRUE;
}

void CMainFrame::OnUpdateUserTools(CCmdUI* pCmdUI) 
{
	int nTool = pCmdUI->m_nID - ID_USER_TOOL1;

	CString strEntry;
	strEntry.Format(_T("MyTool &%u"), nTool + 1);
	pCmdUI->Enable(TRUE);
	pCmdUI->SetText(strEntry);
}

void CMainFrame::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	if (pWnd->GetSafeHwnd () == m_wndClientArea.GetSafeHwnd ())
	{
		CCustToolBarTestApp* pApp = (CCustToolBarTestApp *) AfxGetApp();
		pApp->ShowPopupMenu(IDR_MAIN_FRAME_MENU, point, this);
	}
}
